LeetCode 151 Two Sum

来源:互联网 发布:yyf的淘宝店是哪个 编辑:程序博客网 时间:2024/05/29 17:32
Given an array of integers, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9

Output: index1=1, index2=2

分析:

这个题跟典型的k Sum有所不同,不同点在于,不要求结果是有序的,而是要返回下标,所以不能按顺序遍历。

用HashMap将 target - num[i] 和 i 的键值对存起来,那么当遍历到值为 target-num[i] 的 j 时,可以从HashMap中取出 i。

因为要求返回下标是1开始的,那么就是 i+1,j+1。

public class Solution {    public int[] twoSum(int[] numbers, int target) {       int[] res = new int[2];       HashMap<Integer, Integer> map = new HashMap<Integer, Integer>();       for(int i=0; i<numbers.length; i++){           if(map.containsKey(numbers[i])){               int index = map.get(numbers[i]);               res[0] = index+1;               res[1] = i+1;               break;           }else{               map.put(target-numbers[i], i);           }       }       return res;    }}

另一种解法,原理是一样的,不同点在与放进HashMap得时numbers[i] 和 i 对,跟直观一点。

public class Solution {    public int[] twoSum(int[] numbers, int target) {        int[] res = new int[2];        HashMap<Integer, Integer> map = new HashMap<Integer, Integer>();        for(int i=0; i<numbers.length; i++){            if(map.containsKey(target-numbers[i])){                res[0] = map.get(target-numbers[i])+1;                res[1] = i+1;            }else{                map.put(numbers[i], i);            }        }        return res;    }}


0 0
原创粉丝点击